#! /bin/sh
# the next line restarts using tclsh \
exec `which tclsh` $0 ${1+"$@"}

if {0} {
aMule-Stats client for LCDd
Written 2006 by Jannis Achstetter <jannis_achstetter@web.de>

Changelog:

*v0.2:
  - Added summary screen

*v0.1:
  - Initial release

/Changelog

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
}

## -=- Settings start here -=-

# Delay between updates in ms:
set updatetime 500
set lcddport 13666
set mulewebhost "127.0.0.1"
set mulewebport 4711
set mulewebpw "dasistmeinwebpw"
# show summary-screen:
set summary 1
# show one detailed screen per DL:
set details 1

## -=- Settings end -=-
## You actually don't need to change anything below this line

proc connectlcd {} {
  global lcddport lcdsock

  if {[catch {set lcdsock [socket 127.0.0.1 $lcddport]}]} {
    puts "Error connecting to LCDd on 127.0.0.1:$lcddport"
    cleanexit 1
  }
  fileevent $lcdsock readable [list lcdsockread]

  puts $lcdsock "hello"
  flush $lcdsock
}

proc lcdsockread {} {
  global lcdsock lcdversion lcdwid lcdhgt

  gets $lcdsock line

  if {$line == ""} {
    puts "LCDd died, so we'll suicide! Bye, bye! BOOM!"
    cleanexit 0
  }

  #if {$line != "success" && ![string match *listen* $line] && ![string match *ignore* $line]} {puts "\nLCDd: $line\n"}

  if {[string match {connect LCD*} $line]} {
    set list [split $line]
    set lcdversion [lindex $line 2]
    set lcdprot [lindex $line 4]
    set lcdwid [lindex $line 7]
    set lcdhgt [lindex $line 9]
    set lcdcwid [lindex $line 11]
    set lcdchgt [lindex $line 13]
    puts $lcdsock "client_set name {amulestats}"
    flush $lcdsock
  }
}

proc updatemule {} {
  global mulesock mulewebport mulewebhost mulewebpw

  if {[catch {set mulesock [socket $mulewebhost $mulewebport]}]} {
    puts "Error connecting to aMule-web on $mulewebhost:$mulewebport"
    cleanexit 1
  }
  fileevent $mulesock readable [list sockread]

  set clength [expr [string length $mulewebpw] + 5]
  puts $mulesock "POST / HTTP/1.1"
  puts $mulesock "Host: $mulewebhost:$mulewebport"
  puts $mulesock "Content-Type: application/x-www-urlencoded"
  puts $mulesock "Content-Length: $clength"
  puts $mulesock ""
  puts $mulesock "pass=$mulewebpw"
  flush $mulesock
}

proc sockread {} {
  global mulesock mulesock2 mulewebport mulewebhost

  set line [read $mulesock]
  if {[string match {*Password incorrect*} $line]} {
    puts "Mule-Web-PW incorrect"
    cleanexit 1
  } else {
    if {[string match *SESSID* $line]} {
      close $mulesock
      set sessid [lindex [split [lindex [split $line =] 1] \n] 0]
      set mulesock2 [socket $mulewebhost $mulewebport]
      fileevent $mulesock2 readable [list sockread2]
      puts $mulesock2 "GET /amuleweb-main-dload.php HTTP/1.1"
      puts $mulesock2 "Host: $mulewebhost:$mulewebport"
      puts $mulesock2 "Cookie: SESSID=$sessid"
      puts $mulesock2 ""
      flush $mulesock2
    }
  }
}

proc sockread2 {} {
  global mulesock2 lcdsock lcdwid lcdhgt screens updatetime summary details
  set line [read $mulesock2]
  close $mulesock2
  set list [split $line \n]
  foreach data $list {
    if {[string match *input* $data] && [string match *checkbox* $data]} {
      set data2 [split [string map {input input\n} $data] \n]
      foreach data3 $data2 {
        if {[string match *checkbox* $data3]} {
          set data4 [string map  {</td> \xC8} $data3]
          set dlhash [lindex [split [lindex [split $data4 \xC8] 0] \"] 3]
          set dlname [encoding convertfrom utf-8 [lindex [split [lindex [split [lindex [split $data4 \xC8] 1] >] 1] <] 0]]
          set dlsize [lindex [split [lindex [split [lindex [split $data4 \xC8] 3] >] 1] <] 0]
          set dlcomp [string map {&nbsp; ""} [lindex [split [lindex [split [lindex [split $data4 \xC8] 4] >] 1] <] 0]]
          set dlsources [string map { " " ""} [lindex [split [lindex [split [lindex [split $data4 \xC8] 5] >] 1] <] 0]]
          set dlstatus [lindex [split [lindex [split [lindex [split $data4 \xC8] 6] >] 1] <] 0]
          set dlspeed [lindex [split [lindex [split [lindex [split $data4 \xC8] 7] >] 1] <] 0]
          #puts "\nHash: $dlhash ([string length $dlhash])\nName: $dlname\nSize: $dlsize ([string length $dlsize])\nComp: $dlcomp ([string length $dlcomp])\nSources: $dlsources ([string length $dlsources])\nStatus: $dlstatus ([string length $dlstatus])\nSpeed: $dlspeed ([string length $dlspeed])"
          if {$details} {
            if {[lsearch $screens $dlhash] == -1} {
              puts $lcdsock "screen_add $dlhash"
              puts $lcdsock "screen_set $dlhash name $dlhash"
              puts $lcdsock "widget_add $dlhash title title"
              puts $lcdsock "widget_add $dlhash line1 string"
              puts $lcdsock "widget_add $dlhash line2 string"
              puts $lcdsock "widget_add $dlhash line3 string"
              lappend screens $dlhash
            }
            puts $lcdsock "widget_set $dlhash title {$dlname}"

            set lcdstring $dlsize
            set count [expr $lcdwid - [string length $dlsize] - [string length $dlsources]]
            for {set x 0} {$x<$count} {incr x} {
              append lcdstring " "
            }
            append  lcdstring $dlsources
            puts $lcdsock "widget_set $dlhash line1 1 2 {$lcdstring}"

            set lcdstring $dlcomp
            set count [expr $lcdwid - [string length $dlcomp] - [string length $dlstatus]]
            for {set x 0} {$x<$count} {incr x} {
              append lcdstring " "
            }
            append  lcdstring $dlstatus
            puts $lcdsock "widget_set $dlhash line2 1 3 {$lcdstring}"

            set lcdstring "Speed:"
            set count [expr $lcdwid - 6 - [string length $dlspeed]]
            for {set x 0} {$x<$count} {incr x} {
              append lcdstring " "
            }
            append  lcdstring $dlspeed
            puts $lcdsock "widget_set $dlhash line3 1 4 {$lcdstring}"
          }
          if {$summary} {
            if {[lsearch $screens "summary"] == -1} {
              puts $lcdsock "screen_add summary"
              puts $lcdsock "screen_set summary name summary"
              puts $lcdsock "widget_add summary title title"
              puts $lcdsock "widget_add summary line1 string"
              puts $lcdsock "widget_add summary line2 string"
              puts $lcdsock "widget_add summary line3 string"
              puts $lcdsock "widget_set summary title {aMule summary}"
              lappend screens "summary"
            }
            if {[lsearch $data2 $data3] < $lcdhgt} {
              set perc [lindex [split [lindex [split [lindex [split $dlcomp )] 0] (] 1] %] 0 ]
              set lcdstring "[string range $dlname 0 5] $perc"
              set count [expr $lcdwid - [string length $lcdstring] - [string length $dlspeed]]
              for {set x 0} {$x<$count} {incr x} {
                append lcdstring " "
              }
              if {$dlspeed != "-"} {
                append  lcdstring " $dlspeed"
              } else {
                append  lcdstring "$dlspeed"
              }
              puts $lcdsock "widget_set summary line[lsearch $data2 $data3] 1 [expr [lsearch $data2 $data3] +1] {$lcdstring}"
            }
          }

          flush $lcdsock
        }
      }
    }
  }
  catch {close $mulesock}
  catch {close $mulesock2}
  after $updatetime {updatemule}
}

proc cleanexit {exitcode} {
  global mulesock mulesock2 lcdsock
  catch {close $mulesock}
  catch {close $mulesock2}
  catch {close $lcdsock}
  exit $exitcode
}

#inits
set screens {}

connectlcd
#we have to wait until we know how large the LCD is
vwait lcdwid
updatemule

vwait forever
